\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, sem_t, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/terminator.h}}
\title{An auxiliary library for allocating shared memory among forks.}
\date{\vspace{-5ex}}
\author{\vspace{-5ex}}
\maketitle
\lstset{title=Contents of \texttt{src/forkshare.h}}
\begin{lstlisting}
#ifndef _FORKSHARE_H
#define _FORKSHARE_H

ssize_t d_pagesize(void);

void *forkshare(size_t)
    __attribute__ (( alloc_size(1) ))
    __attribute__ (( malloc ));

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/forkshare.c}}
\begin{lstlisting}
#include <sys/mman.h>
#include <unistd.h>
#include <errno.h>

#include "forkshare.h"
#include "terminator.h"

void *page = NULL;
ssize_t pagesize = 0;
ssize_t used = 0;

#define P_RW PROT_READ | PROT_WRITE
#define M_SA MAP_SHARED | MAP_ANONYMOUS

ssize_t d_pagesize(void)
{
    if (!pagesize)
    {
        pagesize = sysconf(_SC_PAGESIZE);
        if (pagesize == -1)
            terminate(errno, "Unable to get PAGESIZE.\n");
    }
    return pagesize;
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
void *forkshare(size_t size)
{
    // Whole block allocation.
    if (size > d_pagesize())
    {
        void *ret = mmap(NULL, size, P_RW, M_SA, -1, 0);
        if (ret == MAP_FAILED)
            return NULL;
        return ret;
    }

    // Start new page.
    if (size > pagesize - used)
    {
        page = NULL;
        used = 0;
    }

    // Create a shared memory segment.
    if (!page)
        page = mmap(NULL, pagesize, P_RW, M_SA, -1, 0);

    // Unable to mmap.
    if (page == MAP_FAILED)
        return NULL;

    // Success.
    void *ret = (char *)page + used;
    used += size;
    return ret;
}
\end{lstlisting}
\end{document}
